﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Newtonsoft.Json;
using System.Diagnostics;
using System.Threading;
using System.Net;
using System.Text.RegularExpressions;

namespace 哔哩哔哩视频重命名
{
    public partial class MainForm : Form
    {
        #region
        private static Bitmap expand_img = global::哔哩哔哩视频重命名.Properties.Resources.expand;
        private static Bitmap collapse_img = global::哔哩哔哩视频重命名.Properties.Resources.collapse;
        private static Bitmap empty_img = global::哔哩哔哩视频重命名.Properties.Resources.empty;
        private static Bitmap mp4_img = global::哔哩哔哩视频重命名.Properties.Resources.mp4;
        private static Bitmap flv_img = global::哔哩哔哩视频重命名.Properties.Resources.flv;
        private static Bitmap file_img = global::哔哩哔哩视频重命名.Properties.Resources.file;

        private string ffmpegpath = System.AppDomain.CurrentDomain.BaseDirectory + @"\ffmpeg.exe";

        private Color TitleBackColor = Color.FromArgb(187, 206, 8);
        private Color TitleForeColor = Color.FromArgb(255, 255, 255);

        private Color ItemBackColor = Color.FromArgb(255, 255, 255);
        private Color ItemForeColor = Color.FromArgb(68, 68, 68);
        private Color ItemConvertForeColor = Color.DeepSkyBlue;
        private Color ItemSuccessForeColor = Color.OliveDrab;
        private Color ItemErrorForeColor = Color.Tomato;

        private Color ItemSelectBackColor = Color.FromArgb(230, 230, 230);

        private DataGridViewCellStyle TitleCellStyle = new DataGridViewCellStyle();
        private DataGridViewCellStyle ItemCellStyle = new DataGridViewCellStyle();

        private DataTable videodt = new DataTable();
        private ProcessStartInfo psi;
        #endregion

        public MainForm()
        {
            InitializeComponent();

            this.videodt.Columns.Add(new DataColumn("索引", typeof(int)));
            this.videodt.Columns.Add(new DataColumn("类型", typeof(string)));
            this.videodt.Columns.Add(new DataColumn("显示", typeof(bool)));
            this.videodt.Columns.Add(new DataColumn("Logo地址", typeof(string)));
            this.videodt.Columns.Add(new DataColumn("Logo路径", typeof(string)));
            this.videodt.Columns.Add(new DataColumn("按钮类型", typeof(string)));
            this.videodt.Columns.Add(new DataColumn("按钮", typeof(Image)));
            this.videodt.Columns.Add(new DataColumn("文本", typeof(string)));
            this.videodt.Columns.Add(new DataColumn("源视频类型", typeof(string)));
            this.videodt.Columns.Add(new DataColumn("源视频", typeof(Image)));
            this.videodt.Columns.Add(new DataColumn("源视频列表", typeof(Image)));
            this.videodt.Columns.Add(new DataColumn("处理状态", typeof(string)));
            this.videodt.Columns.Add(new DataColumn("源视频路径", typeof(string)));
            this.videodt.Columns.Add(new DataColumn("源视频路径保存", typeof(string)));
            this.videodt.Columns.Add(new DataColumn("源音频路径", typeof(string)));

            this.TitleCellStyle.BackColor = this.TitleBackColor;
            this.TitleCellStyle.ForeColor = this.TitleForeColor;
            this.TitleCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
            this.TitleCellStyle.Font = new Font("微软雅黑", 9);
            this.TitleCellStyle.WrapMode = DataGridViewTriState.False;

            this.ItemCellStyle.BackColor = this.ItemBackColor;
            this.ItemCellStyle.ForeColor = this.ItemForeColor;
            this.ItemCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
            this.ItemCellStyle.Font = new Font("微软雅黑", 9);
            this.ItemCellStyle.WrapMode = DataGridViewTriState.False;

        }

        /// <summary>
        /// 选择源视频根路径
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void selectpathbtn_Click(object sender, EventArgs e)
        {
            try
            {
                this.openpathfbd.RootFolder = Environment.SpecialFolder.Desktop;
                this.openpathfbd.SelectedPath = "c:\\";
                this.openpathfbd.ShowNewFolderButton = false;
                this.openpathfbd.Description = "请选择源视频根目录";

                if (this.openpathfbd.ShowDialog() == DialogResult.OK)
                {
                    this.openpathtb.Text = this.openpathfbd.SelectedPath;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /// <summary>
        /// 打开源视频根路径
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void openpathbtn_Click(object sender, EventArgs e)
        {
            try
            {
                #region
                string _path = this.openpathtb.Text.Trim();
                if (string.IsNullOrWhiteSpace(_path))
                {
                    MessageBox.Show("请选择源视频根路径");
                    return;
                }

                #endregion

                Process proc = new Process();
                proc.StartInfo.FileName = "explorer";
                proc.StartInfo.Arguments = _path;
                proc.Start();
                proc.Dispose();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /// <summary>
        /// 选择视频保存路径
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void selectsavepathbtn_Click(object sender, EventArgs e)
        {
            try
            {
                this.savepathfbd.RootFolder = Environment.SpecialFolder.Desktop;
                this.savepathfbd.SelectedPath = "c:\\";
                this.savepathfbd.ShowNewFolderButton = true;
                this.savepathfbd.Description = "请选择保存根目录";

                if (this.savepathfbd.ShowDialog() == DialogResult.OK)
                {
                    this.savepathtb.Text = this.savepathfbd.SelectedPath;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /// <summary>
        /// 打开视频保存路径
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void opensavepathbtn_Click(object sender, EventArgs e)
        {
            try
            {
                #region
                string _path = this.savepathtb.Text.Trim();
                if (string.IsNullOrWhiteSpace(_path))
                {
                    MessageBox.Show("请选择视频保存路径");
                    return;
                }

                #endregion

                Process proc = new Process();
                proc.StartInfo.FileName = "explorer";
                proc.StartInfo.Arguments = _path;
                proc.Start();
                proc.Dispose();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /// <summary>
        /// 全部展开
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void expandbtn_Click(object sender, EventArgs e)
        {
            try
            {
                for (int i = 0; i < this.videodt.Rows.Count; i++)
                {
                    if (this.videodt.Rows[i]["类型"].ToString() == "title")
                    {
                        this.videodt.Rows[i]["按钮类型"] = "expand";
                        this.videodt.Rows[i]["按钮"] = expand_img;
                    }
                    else if (this.videodt.Rows[i]["类型"].ToString() == "item" || this.videodt.Rows[i]["类型"].ToString() == "file")
                    {
                        this.videodt.Rows[i]["显示"] = true;
                    }
                }
                this.videogv.DataSource = this.GetDataView();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /// <summary>
        /// 全部折叠
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void collapsebtn_Click(object sender, EventArgs e)
        {
            try
            {
                for (int i = 0; i < this.videodt.Rows.Count; i++)
                {
                    if (this.videodt.Rows[i]["类型"].ToString() == "title")
                    {
                        this.videodt.Rows[i]["按钮类型"] = "collapse";
                        this.videodt.Rows[i]["按钮"] = collapse_img;
                    }
                    else if (this.videodt.Rows[i]["类型"].ToString() == "item" || this.videodt.Rows[i]["类型"].ToString() == "file")
                    {
                        this.videodt.Rows[i]["显示"] = false;
                    }
                }
                this.videogv.DataSource = this.GetDataView();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /// <summary>
        /// 全部文件展开
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void fileexpandbtn_Click(object sender, EventArgs e)
        {
            try
            {
                for (int i = 0; i < this.videodt.Rows.Count; i++)
                {
                    if (this.videodt.Rows[i]["类型"].ToString() == "file")
                    {
                        this.videodt.Rows[i]["显示"] = true;
                    }
                }
                this.videogv.DataSource = this.GetDataView();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        /// <summary>
        /// 全部文件折叠
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void filecollapsebtn_Click(object sender, EventArgs e)
        {
            try
            {
                for (int i = 0; i < this.videodt.Rows.Count; i++)
                {
                    if (this.videodt.Rows[i]["类型"].ToString() == "file")
                    {
                        this.videodt.Rows[i]["显示"] = false;
                    }
                }
                this.videogv.DataSource = this.GetDataView();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /// <summary>
        /// 加载目录
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void loadbtn_Click(object sender, EventArgs e)
        {
            try
            {
                this.videodt.Clear();
                int rowindex = 0;

                string openpathbase = this.openpathtb.Text.Trim();
                if (string.IsNullOrWhiteSpace(openpathbase))
                {
                    MessageBox.Show("源视频根路径");
                    return;
                }

                string savepathbase = this.savepathtb.Text.Trim();
                if (string.IsNullOrWhiteSpace(savepathbase))
                {
                    MessageBox.Show("视频保存路径");
                    return;
                }

                #region

                string[] video_collection_folder_arr = Directory.GetDirectories(openpathbase);
                for (int i = 0; i < video_collection_folder_arr.Length; i++)//历遍视频目录集合
                {
                    DataRow title_dr = this.videodt.NewRow();
                    title_dr["索引"] = rowindex;
                    title_dr["类型"] = "title";
                    title_dr["显示"] = true;
                    title_dr["按钮类型"] = "expand";
                    title_dr["按钮"] = expand_img;
                    title_dr["文本"] = "(" + i.ToString().PadLeft(2, '0') + ")_" + video_collection_folder_arr[i].Substring(openpathbase.Length + 1, video_collection_folder_arr[i].Length - openpathbase.Length - 1);
                    title_dr["源视频类型"] = "";
                    title_dr["源视频"] = empty_img;
                    title_dr["源视频列表"] = empty_img;
                    title_dr["处理状态"] = "";
                    title_dr["源视频路径"] = "";
                    title_dr["源视频路径保存"] = "";
                    title_dr["源音频路径"] = "";
                    videodt.Rows.Add(title_dr);
                    rowindex++;

                    #region
                    string[] video_folder_arr = Directory.GetDirectories(video_collection_folder_arr[i]);
                    for (int k = 0; k < video_folder_arr.Length; k++)//历遍视频目录
                    {
                        string video_title = "";

                        string entryjson_path = video_folder_arr[k] + @"\entry.json";//视频描述json
                        VideoJson vj = JsonConvert.DeserializeObject<VideoJson>(File.ReadAllText(entryjson_path, Encoding.UTF8));
                        if (vj.page_data != null)
                        {
                            video_title = ViladPath(vj.page_data.part);
                        }
                        else
                        {
                            video_title = ViladPath(vj.ep.index_title);
                        }
                        vj.title = ViladPath(vj.title);

                        if (k == 0)
                        {
                            title_dr["文本"] += "___" + vj.title;
                            title_dr["Logo地址"] = vj.cover;
                            title_dr["Logo路径"] = savepathbase + @"\" + title_dr["文本"] + @"\" + title_dr["文本"] + ".jpg";
                        }

                        #region
                        string[] video_children_folder_arr = Directory.GetDirectories(video_folder_arr[k]);
                        bool isfarst = true;
                        int filesum = 0;
                        for (int j = 0; j < video_children_folder_arr.Length; j++)//存放视频文件子目录
                        {
                            string[] video_arr = null;
                            List<VideoClass> videolist = new List<VideoClass>();
                            if (vj.media_type == 2)
                            {
                                video_arr = Directory.GetFiles(video_children_folder_arr[j]).Where(a => a.ToLower().EndsWith("video.m4s")).ToArray();
                            }
                            else if (vj.media_type == 1)
                            {
                                foreach (string str in Directory.GetFiles(video_children_folder_arr[j]).Where(a => a.ToLower().EndsWith(".blv")).ToList())
                                {
                                    videolist.Add(new VideoClass() { index = int.Parse(Path.GetFileNameWithoutExtension(str)), path = str });
                                }
                                video_arr = videolist.OrderBy(a => a.index).Select(a => a.path).ToArray();
                            }


                            if (video_arr.Length > 0)
                            {
                                #region
                                for (int v = 0; v < video_arr.Length; v++)
                                {
                                    #region
                                    if (vj.media_type == 2)
                                    {
                                        string video_source = video_children_folder_arr[j] + @"\video.m4s";
                                        string audio_source = video_children_folder_arr[j] + @"\audio.m4s";

                                        filesum++;
                                        if (isfarst)
                                        {
                                            isfarst = false;
                                            DataRow mp4_dr = videodt.NewRow();
                                            mp4_dr["索引"] = rowindex;
                                            mp4_dr["类型"] = "item";
                                            mp4_dr["显示"] = true;
                                            mp4_dr["按钮类型"] = "nullempty";
                                            mp4_dr["按钮"] = empty_img;
                                            mp4_dr["文本"] = "(" + (k + 1).ToString().PadLeft(3, '0') + ")_" + video_title;
                                            mp4_dr["源视频类型"] = "mp4";
                                            mp4_dr["源视频"] = mp4_img;
                                            mp4_dr["源视频列表"] = empty_img;
                                            mp4_dr["处理状态"] = "预备";
                                            mp4_dr["源视频路径"] = video_source;
                                            mp4_dr["源视频路径保存"] = savepathbase + @"\" + title_dr["文本"] + @"\" + mp4_dr["文本"] + ".mp4";
                                            mp4_dr["源音频路径"] = audio_source;
                                            this.videodt.Rows.Add(mp4_dr);
                                            rowindex++;
                                        }

                                        DataRow mp4_file_dr = videodt.NewRow();
                                        mp4_file_dr["索引"] = rowindex;
                                        mp4_file_dr["类型"] = "file";
                                        mp4_file_dr["显示"] = true;
                                        mp4_file_dr["按钮类型"] = "nullempty";
                                        mp4_file_dr["按钮"] = empty_img;
                                        mp4_file_dr["文本"] = Path.GetFileName(video_arr[v]);
                                        mp4_file_dr["源视频类型"] = "mp4";
                                        mp4_file_dr["源视频"] = empty_img;
                                        mp4_file_dr["源视频列表"] = file_img;
                                        mp4_file_dr["处理状态"] = "";
                                        mp4_file_dr["源视频路径"] = video_source;
                                        mp4_file_dr["源视频路径保存"] = "";
                                        mp4_file_dr["源音频路径"] = audio_source;
                                        this.videodt.Rows.Add(mp4_file_dr);
                                        rowindex++;
                                    }
                                    else if (vj.media_type == 1)
                                    {
                                        filesum++;
                                        if (isfarst)
                                        {
                                            isfarst = false;
                                            DataRow flv_dr = videodt.NewRow();
                                            flv_dr["索引"] = rowindex;
                                            flv_dr["类型"] = "item";
                                            flv_dr["显示"] = true;
                                            flv_dr["按钮类型"] = "nullempty";
                                            flv_dr["按钮"] = empty_img;
                                            flv_dr["文本"] = "(" + (k + 1).ToString().PadLeft(3, '0') + ")_" + video_title;
                                            flv_dr["源视频类型"] = "blv";
                                            flv_dr["源视频"] = flv_img;
                                            flv_dr["源视频列表"] = empty_img;
                                            flv_dr["处理状态"] = "预备";
                                            flv_dr["源视频路径"] = video_arr[v];
                                            flv_dr["源视频路径保存"] = savepathbase + @"\" + title_dr["文本"] + @"\" + flv_dr["文本"] + ".mp4";
                                            flv_dr["源音频路径"] = "";
                                            this.videodt.Rows.Add(flv_dr);
                                            rowindex++;
                                        }

                                        DataRow flv_file_dr = videodt.NewRow();
                                        flv_file_dr["索引"] = rowindex;
                                        flv_file_dr["类型"] = "file";
                                        flv_file_dr["显示"] = true;
                                        flv_file_dr["按钮类型"] = "nullempty";
                                        flv_file_dr["按钮"] = empty_img;
                                        flv_file_dr["文本"] = Path.GetFileName(video_arr[v]);
                                        flv_file_dr["源视频类型"] = "blv";
                                        flv_file_dr["源视频"] = empty_img;
                                        flv_file_dr["源视频列表"] = file_img;
                                        flv_file_dr["处理状态"] = "";
                                        flv_file_dr["源视频路径"] = video_arr[v];
                                        flv_file_dr["源视频路径保存"] = "";
                                        flv_file_dr["源音频路径"] = "";
                                        this.videodt.Rows.Add(flv_file_dr);
                                        rowindex++;
                                    }
                                    #endregion
                                }
                                #endregion
                                break;
                            }
                        }
                        #endregion
                    }
                    #endregion
                }
                #endregion

                this.videosval.Text = String.Format("0/{0}", video_collection_folder_arr.Length.ToString());
                this.proval.Text = String.Format("0/{0}", this.videodt.Select(" 类型='item' ").Count());
                this.videogv.DataSource = this.GetDataView();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.StackTrace);
            }
        }



        /// <summary>
        /// 开始处理
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void startbtn_Click(object sender, EventArgs e)
        {
            try
            {
                if (!this.logocb.Checked && !this.videocb.Checked)
                {
                    MessageBox.Show("请选择要处理操作");
                    return;
                }

                this.selectpathbtn.Enabled = false;
                this.selectsavepathbtn.Enabled = false;
                this.logocb.Enabled = false;
                this.videocb.Enabled = false;
                this.loadbtn.Enabled = false;
                this.startbtn.Enabled = false;

                Action<bool, bool> videoaction = (bool islogo, bool isvideo) =>
                {
                    int titlecount = this.videodt.Select(" 类型='title' ").Count();
                    int titleindex = 0;
                    for (int i = 0; i < this.videodt.Rows.Count; i++)
                    {
                        #region
                        if (this.videodt.Rows[i]["类型"].ToString() == "title")
                        {
                            titleindex++;
                            this.Invoke(new MethodInvoker(delegate()
                            {
                                this.videosval.Text = String.Format("{0}/{1}", titleindex, titlecount);
                            }));


                            if (!islogo)
                            {
                                continue;
                            }

                            int count = 0;
                            HttpWebResponse response = null;
                            Image logo = null;
                        down:

                            try
                            {
                                count++;
                                #region 下载logo

                                string logopath = Path.GetDirectoryName(this.videodt.Rows[i]["Logo路径"].ToString());
                                if (!Directory.Exists(logopath))
                                {
                                    Directory.CreateDirectory(logopath);
                                }

                                HttpWebRequest request = (HttpWebRequest)HttpWebRequest.Create(this.videodt.Rows[i]["Logo地址"].ToString());
                                request.Method = "GET";

                                response = (HttpWebResponse)request.GetResponse();

                                logo = Image.FromStream(response.GetResponseStream());
                                logo.Save(this.videodt.Rows[i]["Logo路径"].ToString());

                                response.Close();
                                logo.Dispose();
                                #endregion
                            }
                            catch (WebException ex)
                            {
                                if (ex.Status == WebExceptionStatus.Timeout && count < 3)
                                {
                                    goto down;
                                }
                                response.Close();
                                logo.Dispose();
                            }

                        }
                        #endregion
                        #region
                        else if (this.videodt.Rows[i]["类型"].ToString() == "item")
                        {
                            if (!isvideo)
                            {
                                continue;
                            }

                            Process process = null;
                            this.psi = new ProcessStartInfo(this.ffmpegpath);
                            this.psi.UseShellExecute = false;
                            this.psi.CreateNoWindow = true;
                            this.psi.WindowStyle = ProcessWindowStyle.Hidden;
                            this.psi.RedirectStandardError = true;
                            this.psi.RedirectStandardOutput = true;
                            this.psi.StandardOutputEncoding = Encoding.UTF8;
                            this.psi.StandardErrorEncoding = Encoding.UTF8;

                            #region
                            if (this.videodt.Rows[i]["源视频类型"].ToString() == "mp4")
                            {
                                this.Invoke(new MethodInvoker(delegate()
                                {
                                    this.videodt.Rows[i]["处理状态"] = "处理中";
                                    this.videogv.DataSource = this.GetDataView();
                                }));

                                string videopath_tmp = Path.GetDirectoryName(this.videodt.Rows[i]["源视频路径保存"].ToString());
                                if (!Directory.Exists(videopath_tmp))
                                {
                                    Directory.CreateDirectory(videopath_tmp);
                                }

                                try
                                {
                                    this.psi.Arguments = String.Format(" -i \"{0}\" -i \"{1}\" -vcodec copy -acodec copy -y \"{2}\" ", this.videodt.Rows[i]["源视频路径"].ToString(), this.videodt.Rows[i]["源音频路径"].ToString(), this.videodt.Rows[i]["源视频路径保存"].ToString());

                                    process = Process.Start(this.psi);
                                    string error = process.StandardError.ReadToEnd();
                                    process.WaitForExit();

                                    this.Invoke(new MethodInvoker(delegate()
                                    {
                                        this.videodt.Rows[i]["处理状态"] = "完成";
                                        this.proval.Text = this.GetProgress();
                                        this.videogv.DataSource = this.GetDataView();
                                    }));
                                }
                                catch (Exception ex)
                                {
                                    this.Invoke(new MethodInvoker(delegate()
                                    {
                                        this.videodt.Rows[i]["处理状态"] = "失败";
                                        this.proval.Text = this.GetProgress();
                                        this.videogv.DataSource = this.GetDataView();
                                    }));
                                }
                            }
                            #endregion
                            #region
                            else if (this.videodt.Rows[i]["源视频类型"].ToString() == "blv")
                            {
                                this.Invoke(new MethodInvoker(delegate()
                                {
                                    this.videodt.Rows[i]["处理状态"] = "处理中";
                                    this.videogv.DataSource = this.GetDataView();
                                }));

                                string videopath_tmp = Path.GetDirectoryName(this.videodt.Rows[i]["源视频路径保存"].ToString());
                                if (!Directory.Exists(videopath_tmp))
                                {
                                    Directory.CreateDirectory(videopath_tmp);
                                }

                                try
                                {
                                    List<VideoClass> videolist = new List<VideoClass>();

                                    foreach (string str in Directory.GetFiles(Path.GetDirectoryName(this.videodt.Rows[i]["源视频路径"].ToString())).Where(a => a.ToLower().EndsWith(".blv")).ToList())
                                    {
                                        videolist.Add(new VideoClass() { index = int.Parse(Path.GetFileNameWithoutExtension(str)), path = str });
                                    }
                                    List<string> fileList = videolist.OrderBy(a => a.index).Select(a => a.path).ToList<string>();

                                    if (fileList.Count == 1)
                                    {
                                        File.Copy(this.videodt.Rows[i]["源视频路径"].ToString(), videodt.Rows[i]["源视频路径保存"].ToString(), true);
                                    }
                                    else
                                    {
                                        #region
                                        {
                                            string tmp = Path.GetDirectoryName(this.videodt.Rows[i]["源视频路径"].ToString()) + "\\tmp";

                                            string ffmpegpath = AppDomain.CurrentDomain.BaseDirectory + "ffmpeg.exe";
                                            ProcessStartInfo psi = new ProcessStartInfo(ffmpegpath);
                                            psi.UseShellExecute = false;
                                            psi.CreateNoWindow = true;
                                            psi.WindowStyle = ProcessWindowStyle.Hidden;
                                            psi.RedirectStandardError = true;
                                            psi.RedirectStandardOutput = true;
                                            psi.StandardOutputEncoding = Encoding.UTF8;
                                            psi.StandardErrorEncoding = Encoding.UTF8;
                                            Process process_convert = null;
                                            string error = "";

                                            string cmd = "  -f concat -safe 0 -i \"{0}\" -c copy -y \"{1}\"   ";
                                            StringBuilder cmd_arg = new StringBuilder();

                                            string tmpfile = Path.GetDirectoryName(this.videodt.Rows[i]["源视频路径"].ToString()) + "\\filelist.txt";
                                            FileStream fs = new FileStream(tmpfile, FileMode.Create);

                                            for (int k = i + 1; k < this.videodt.Rows.Count; k++)
                                            {
                                                if (this.videodt.Rows[k]["类型"].ToString() == "item" || this.videodt.Rows[k]["类型"].ToString() == "title")
                                                {
                                                    break;
                                                }

                                                byte[] data = System.Text.Encoding.Default.GetBytes("file '" + this.videodt.Rows[k]["源视频路径"].ToString() + "'\r\n");
                                                fs.Write(data, 0, data.Length);
                                            }
                                            fs.Flush();
                                            fs.Close();


                                            psi.Arguments = String.Format(cmd, tmpfile, videodt.Rows[i]["源视频路径保存"].ToString());
                                            process_convert = Process.Start(psi);
                                            error = process_convert.StandardError.ReadToEnd();
                                            process_convert.WaitForExit();

                                        }
                                        #endregion
                                    }

                                    this.Invoke(new MethodInvoker(delegate()
                                    {
                                        this.videodt.Rows[i]["处理状态"] = "完成";
                                        this.proval.Text = this.GetProgress();
                                        this.videogv.DataSource = this.GetDataView();
                                   }));
                                }
                                catch (Exception ex)
                                {
                                    this.Invoke(new MethodInvoker(delegate()
                                    {
                                        this.videodt.Rows[i]["处理状态"] = "失败";
                                        this.proval.Text = this.GetProgress();
                                        this.videogv.DataSource = this.GetDataView();
                                    }));
                                }
                            }
                            #endregion
                            if (process != null)
                                process.Dispose();
                        }
                        #endregion
                    }

                    this.Invoke(new MethodInvoker(delegate()
                    {
                        this.selectpathbtn.Enabled = true;
                        this.selectsavepathbtn.Enabled = true;
                        this.logocb.Enabled = true;
                        this.videocb.Enabled = true;
                        this.loadbtn.Enabled = true;
                        this.startbtn.Enabled = true;
                    }));
                };

                AsyncCallback callFun = (result) => { ((Action<bool, bool>)result.AsyncState).EndInvoke(result); };
                videoaction.BeginInvoke(this.logocb.Checked, this.videocb.Checked, callFun, videoaction);
            }
            catch (Exception ex)
            {
                this.selectpathbtn.Enabled = true;
                this.selectsavepathbtn.Enabled = true;
                this.logocb.Enabled = true;
                this.videocb.Enabled = true;
                this.loadbtn.Enabled = true;
                this.startbtn.Enabled = true;
                MessageBox.Show(ex.StackTrace);
            }
        }

        private void videogv_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.ColumnIndex == 6 && this.videogv.Rows[e.RowIndex].Cells[1].Value.ToString() == "title")
            {
                int index = (int)this.videogv.Rows[e.RowIndex].Cells[0].Value;

                if (this.videodt.Rows[index]["按钮类型"].ToString() == "collapse")
                {
                    this.videodt.Rows[index]["按钮"] = expand_img;
                    this.videodt.Rows[index]["按钮类型"] = "expand";
                    for (int i = index + 1; i < this.videodt.Rows.Count; i++)
                    {
                        if (this.videodt.Rows[i]["类型"].ToString() == "title")
                            break;
                        this.videodt.Rows[i]["显示"] = true;
                    }
                }
                else if (this.videodt.Rows[index]["按钮类型"].ToString() == "expand")
                {
                    this.videodt.Rows[index]["按钮"] = collapse_img;
                    this.videodt.Rows[index]["按钮类型"] = "collapse";
                    for (int i = index + 1; i < this.videodt.Rows.Count; i++)
                    {
                        if (this.videodt.Rows[i]["类型"].ToString() == "title")
                            break;
                        this.videodt.Rows[i]["显示"] = false;
                    }
                }

                this.videogv.DataSource = this.GetDataView();
            }

        }

        private void videogv_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            int index = (int)this.videogv.Rows[e.RowIndex].Cells[0].Value;
            if (index > -1)
            {
                if (this.videodt.Rows[index]["类型"].ToString() == "title")
                {
                    e.CellStyle = this.TitleCellStyle;
                    e.CellStyle.SelectionBackColor = this.TitleBackColor;
                    e.CellStyle.SelectionForeColor = this.TitleForeColor;
                }
                else if (this.videodt.Rows[index]["类型"].ToString() == "item")
                {
                    e.CellStyle = this.ItemCellStyle;
                    e.CellStyle.SelectionBackColor = this.ItemSelectBackColor;
                    if (this.videogv.Columns[e.ColumnIndex].DataPropertyName == "处理状态")
                    {
                        if (e.Value.ToString() == "处理中")
                            e.CellStyle.ForeColor = this.ItemConvertForeColor;
                        else if (e.Value.ToString() == "完成")
                            e.CellStyle.ForeColor = this.ItemSuccessForeColor;
                        else if (e.Value.ToString() == "失败")
                            e.CellStyle.ForeColor = this.ItemErrorForeColor;
                        else
                            e.CellStyle.ForeColor = this.ItemForeColor;
                    }
                    else
                    {
                        e.CellStyle.ForeColor = this.ItemForeColor;
                    }
                    e.CellStyle.SelectionForeColor = this.ItemForeColor;
                }
                else if (this.videodt.Rows[index]["类型"].ToString() == "file")
                {
                    e.CellStyle = this.ItemCellStyle;
                    e.CellStyle.SelectionBackColor = this.ItemSelectBackColor;
                }
            }
        }

        /// <summary>
        /// 获取显示数据
        /// </summary>
        /// <returns></returns>
        private DataTable GetDataView()
        {
            DataView videodv = videodt.DefaultView;
            videodv.RowFilter = " 显示=true ";
            return videodv.ToTable();
        }

        /// <summary>
        /// 获取进度
        /// </summary>
        /// <returns></returns>
        private string GetProgress()
        {
            return String.Format("{0}/{1}", videodt.Select(" 处理状态='完成' or 处理状态='失败' ").Count(), videodt.Select(" 类型='item' ").Count());
        }

        /// <summary>
        /// 过滤路径特殊字符
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        private string ViladPath(string path)
        {
            string invalid = new string(Path.GetInvalidFileNameChars()) + new string(Path.GetInvalidPathChars());
            foreach (char c in invalid)
            {
                path = path.Replace(c.ToString(), "");
            }
            return path;
        }

        /// <summary>
        ///  
        /// </summary>
        public class VideoClass
        {
            /// <summary>
            /// 
            /// </summary>
            public int index;
            /// <summary>
            /// 
            /// </summary>
            public string path;

        }

        /// <summary>
        ///  临时文件
        /// </summary>
        public class ItemClass
        {
            /// <summary>
            /// 临时文件路径
            /// </summary>
            public string tmpfile;
            /// <summary>
            /// 临时文件合成命令
            /// </summary>
            public string arg;

        }
        /// <summary>
        /// 视频集
        /// </summary>
        private class VideoJson
        {
            /// <summary>
            /// 类型编码(1blv项目、2m4s项目)
            /// </summary>
            public int media_type { get; set; }
            /// <summary>
            /// 视频集标题
            /// </summary>
            public string title { get; set; }
            /// <summary>
            /// 视频集图片
            /// </summary>
            public string cover { get; set; }
            /// <summary>
            /// 视频详细信息
            /// </summary>
            public VideoJsonIltem1 page_data { get; set; }
            /// <summary>
            /// 视频详细信息
            /// </summary>
            public VideoJsonIltem2 ep { get; set; }

        }

        /// <summary>
        /// 视频详细信息
        /// </summary>
        private class VideoJsonIltem1
        {
            /// <summary>
            /// 视频名称
            /// </summary>
            public string part { get; set; }
        }

        /// <summary>
        /// 视频详细信息
        /// </summary>
        private class VideoJsonIltem2
        {
            /// <summary>
            /// 视频名称
            /// </summary>
            public string index_title { get; set; }
        }
    }

}
